<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// php Infinite Scroll v2.21
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : NFSRL-221
// URL : http://www.phpkobo.com/php-infinite-scroll
//
// This software is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; version 2 of the
// License.
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CBend_alist extends CBend_crud {

	public function init() {
		$this->tbl_name = "alist";
		$this->id_name = "alist_id";
		parent::init();

		$this->bind("hd_edit_inp");
		$this->bind("hd_edit_done");
	}

	public function setupRec( &$rs ) {
		if ( !isset($rs["gname"]) ) {
			$rs["gname"] = ( isset($rs["username"]) ) ?
				$rs["username"] : "";
		}
	}

	protected function validate( $data ) {

		//-- locale
		$lca = CEnv::locale( $this->tbl_name."/validate" );

		//-- vali macro
		CValiMacro::setup($data, $lca);
		CInpArticle::validate( $data );
	}

	public function pc_edit_inp( $data ) {

		//-- select clause
		$sx = array(
			$this->id_name,
			"alist.dt_create",
		);
		$data->clx[] = CSql::clSelect($sx);

		//-- from clause
		$fromx = array();
		$fromx[] = CSql::clFrom($this->tbl_name);
		$fromx[] = CSql::clLeftJoin("user","group_id",
			$this->tbl_name,"group_id");
		$data->clx[] = implode("\n",$fromx);

		//-- return subcmd
		$data->resp['subcmd'] = $data->requ["subcmd"];
	}

	public function pc_edit_done_after_save( $data ) {
		CInpArticle::saveData( $data );
	}

}

?>