/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// php Infinite Scroll v2.21
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : NFSRL-221
// URL : http://www.phpkobo.com/php-infinite-scroll
//
// This software is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; version 2 of the
// License.
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/

(function($){

CAlist = {

	init : function( opt ) {
		for ( var key in opt ) { this[key] = opt[key]; }

		var _this = this;
		this.b_load = false;

		this.jqo_ctar_criteria = this.jqo_ctar.find(".ctar-criteria");
		this.jqo_ctar_dtable = this.jqo_ctar.find(".ctar-dtable");

		this.cajax = new CCAjax();
		this.jms = new CJMS();
		this.dtable = new CDTable({jms:this.jms,
			jqo_ctar_dtable:this.jqo_ctar_dtable});

		this.pc_edit_inp(1001,"settings");

		this.jms.bind( "rp_edit_inp", this, function( resp ) {
			if ( CFRes.execute(resp) ) {
				CAlistRec.open(resp);
			}
		});

		CAlistRec.init({
			jqo_ctar_main:$(".main-container")
		});
	},

	getID : function( jqo ) {
		return jqo.parents(".dtbl-row").attr("data-id");
	},

	setupDetailPage : function( cmd, resp ) {

		var _this = this;

		var lca = CJRLdr.locale("alist/bcrumb");
		var jqo = CPageStack.pushPage( this.jqo_ctar, resp.html, lca["bcrumb:" + cmd] );
		this.jqo_ctar_form = jqo.find(".ctar-form");

		//-- init components
		initCInpCb();
		initCInpRb();

		jqo.find(".btn-cancel").click(function(e){
			e.preventDefault();
			CPageStack.popPage();
		});

		if ( cmd == "reg" ) {
			jqo.find(".btn-ok").click(function(e){
				e.preventDefault();
				_this.pc_reg_done();
			});
		} else {
			jqo.find(".btn-ok").click(function(e){
				e.preventDefault();
				_this.pc_edit_done();
			});
		}

		//-- disable enter key in input
		jqo.find("input").keypress(function(e) {
			if (e.which == 13) {
				e.preventDefault()
			}
		});

		//-- focus fisrt input
		jqo.find("input[name='title']").select();

		//-- update scroll btn
		CScrollBtn.update();
	},

	activate : function( opt ) {
		for ( var key in opt ) { this[key] = opt[key]; }

		if ( !this.b_load || this.b_reload ) {
			this.b_load = true;
			this.jms.trigger("do_search");
		}
	},

	pc_edit_inp : function( id, subcmd ) {
		var requ = {
			cmd:"edit_inp",
			subcmd:subcmd,
			id:id
		};
		this.cajax.send(requ,this,function(resp){
			this.jms.trigger("rp_edit_inp",resp);
		});
	}

};

$(document).ready(function(){
	CAlist.init({jqo_ctar:$(".ctar-alist")});
	CAlist.activate();
});

}(jQuery));
