/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// php Infinite Scroll v2.21
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : NFSRL-221
// URL : http://www.phpkobo.com/php-infinite-scroll
//
// This software is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; version 2 of the
// License.
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/

(function($){

CAlistRec = {

	init : function( opt ) {
		for ( var key in opt ) { this[key] = opt[key]; }

		var _this = this;

		this.cajax = new CCAjax();
		this.jms = new CJMS();
	},

	selectTab : function( tab ) {
		this.jqo_menu.find("li").removeClass("active");
		this.jqo_menu.find(".alistrec-tab-btn-"+tab).addClass("active");

		this.jqo_ctarent.find(".alistrec-tab-content").hide();
		this.jqo_ctarent.find(".alistrec-tab-content-"+tab).show();
		this["activate_tab_"+tab.replace("-","_")]();
		
		CScrollBtn.update();
	},

	activate_tab_settings : function() {
		CAlistRecSettingsPanel.activate();
	},

	activate_tab_preview : function() {
		CAlistRecPreviewPanel.activate();
	},

	activate_tab_trans : function() {
		CAlistRecTransPanel.activate();
	},

	open : function( resp ) {
		var _this = this;

		var lca = CJRLdr.locale("alist/bcrumb");
		var jqo = CPageStack.pushPage( null, resp.html, lca["bcrumb:edit"]);

		this.jqo_ctar = this.jqo_ctar_main.prev(".alistrec-ctar");
		this.jqo_menu = this.jqo_ctar.find(".alistrec-menu");
		this.jqo_ctarent = this.jqo_ctar.find(".alistrec-content");

		this.id = resp.id;

		//-- init components
		initCInpSave();
		initCInpCb();
		initCInpRb();

		this.jqo_menu.find(".btn-close").click(function(e){
			e.preventDefault();
			_this.pc_close();
		});

		this.jqo_menu.find(".alistrec-tab-btn-settings").click(function(e){
			e.preventDefault();
			_this.pc_tab_settings();
		});

		this.jqo_menu.find(".alistrec-tab-btn-preview").click(function(e){
			e.preventDefault();
			_this.pc_tab_preview();
		});

		CAlistRecSettingsPanel.init({
			id:this.id,
			jqo_ctar:this.jqo_ctarent.find(".alistrec-tab-content-settings")
		});

		CAlistRecPreviewPanel.init({
			id:this.id,
			jqo_ctar:this.jqo_ctarent.find(".alistrec-tab-content-preview")
		});

		this.selectTab(resp.subcmd);
	},

	pc_close : function() {
		CPageStack.popPage();
		CAlist.activate({b_reload:true});
	},

	pc_tab_settings : function() {
		this.selectTab("settings");
	},

	pc_tab_preview : function() {
		this.selectTab("preview");
	}

};

}(jQuery));
