<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// php Infinite Scroll v2.21
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : NFSRL-221
// URL : http://www.phpkobo.com/php-infinite-scroll
//
// This software is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; version 2 of the
// License.
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CBend_dlgarticle extends CBend_crud {

	public function init() {
		$this->bind("hd_load");
		$this->bind("hd_save");

		$this->tbl_name = "article";
		$this->id_name = "article_id";
	}

	public function hd_load( $data ) {
		$data->vx = array();

		//-- record id
		$id = $data->requ["id"];

		//-- open database
		CDb::open();

		//-- build clauses
		$clx = array();

		//-- select clause
		$data->clx =& $clx;

		//-- select clause
		$data->clx[] = CSql::clSelect(array(
			"content",
		));

		$data->clx[] = CSql::clFrom($this->tbl_name);

		//-- where clause
		$cond = array();
		$cond[] = CSql::clCond($this->id_name,"=",$id);
		if ( count($cond) > 0  ) {
			$clx[] = CSql::clWhere("AND",$cond);
		}

		//-- run query
		$result = CSql::query($clx);
		if ( CDb::getRowCount( $result ) == 0 ) {
			$this->retNotExist($data);
			return;
		}

		$rs = CDb::getRowA( $result );

		//-- resp
		$data->resp["content"] = $rs["content"];
		$data->resp["id"] = $id;
		$this->ret($data);

		CDb::freeResult($result);
	}

	protected function validate( $data ) {

		//-- locale
		$lca = CEnv::locale( "inparticle/validate" );

		//-- vali macro
		CValiMacro::setup($data, $lca);
		CValiMacro::vStr("title");
		CValiMacro::vStr("content");
	}

	public function hd_save( $data ) {
		$data->vx = array();
		$data->fm = $data->requ["form"];
		$id = intval($data->requ["id"]);
		$alist_id = intval($data->requ["alist_id"]);

		//-- validate
		$this->validate( $data );
		if ( !CFRes::isValidated() ) {
			$this->ret($data);
			return;
		}

		//-- open database
		CDb::open();

		if ( $id ) {
			//-- build clauses
			$clx = array();

			//-- update clause
			$clx[] = CSql::clUpdate($this->tbl_name,$data->vx);

			//-- where clause
			$cond = array();
			$cond[] = CSql::clCond($this->id_name,"=",$id);
			if ( count($cond) > 0  ) {
				$clx[] = CSql::clWhere("AND",$cond);
			}

			//-- run query
			CSql::query($clx);

			//-- return id
			$data->resp["id"] = $id;
		} else {
			//-- insert a record
			$data->vx["dt_create"] = gmdate("Y-m-d H:i:s");
			$data->vx["alist_id"] = $alist_id;
			$data->id = CTable::insertRec( $this->tbl_name, $data->vx );
			$data->resp["id"] = $data->id;
		}

		self::ret( $data );
	}

}

?>