<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// php Infinite Scroll v2.21
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : NFSRL-221
// URL : http://www.phpkobo.com/php-infinite-scroll
//
// This software is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; version 2 of the
// License.
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CInpArticle {

	public static function loadData( $alist_id ) {

		CDb::open();

		$rsx = CTable::selectRec(
			"article",
			array("article_id","title"),
			array(
				CSql::clCond( "alist_id", "=", $alist_id ),
				CSql::clCond( "status", "=", 1 ),
			),
			"ORDER BY " . CSql::expOrderBy( array("idx"=>"ASC") )
		);

		$ax = array();
		foreach( $rsx as $rs ) {
			$ax[] = array(
				"id"=>$rs["article_id"],
				"title"=>$rs["title"],
			);
		}
		
		return CJson::encode(array(
			"alist_id"=>$alist_id,
			"list"=>$ax
		));
	}

	public static function validate( $data ) {
		$articles = $data->fm["articles"];
		$idx = 0;
		$rx = array();
		foreach( $articles as $article ) {
			if ( !$article["id"] ) {
				$rx[$idx] = "empty";
			}
			$idx++;
		}
		$data->resp["inparticle"] = $rx;
		if ( count($rx) ) {
			$lca = CEnv::locale( "inparticle/validate" );
			CFRes::addEA( $lca["err:empty:article"] );
		}
	}

	public static function saveData( $data ) {
		$alist_id = $data->id;

		//-- set status to 0 for all records with alist_id
		$clx = array();
		$clx[] = CSql::clUpdate("article",array("status"=>0));
		$cond = array();
		$cond[] = CSql::clCond("alist_id","=",$alist_id);
		if ( count($cond) > 0  ) {
			$clx[] = CSql::clWhere("AND",$cond);
		}
		CSql::query($clx);
		
		//-- set status and idx for all article records
		$idx = 1;
		foreach( $data->fm["articles"] as $ax ) {
			$article_id = $ax["id"];

			$clx = array();
			$clx[] = CSql::clUpdate("article",array(
				"status"=>1,
				"idx"=>$idx,
			));
			$cond = array();
			$cond[] = CSql::clCond("article_id","=",$article_id);
			if ( count($cond) > 0  ) {
				$clx[] = CSql::clWhere("AND",$cond);
			}
			CSql::query($clx);

			$idx++;
		}

		//-- delete records with statue=0
		$clx = array();
		$clx[] = CSql::clDelete("article");
		$cond = array();
		$cond[] = CSql::clCond("alist_id","=",$alist_id);
		$cond[] = CSql::clCond("status","=",0);
		$clx[] = CSql::clWhere("AND",$cond);
		CSql::query($clx);
	}

	public static function delData( $alist_id ) {
		CTable::deleteByID( "article", "alist_id", $alist_id );
	}

	public static function copyData( $org_id, $new_id ) {

		$rsx = CTable::selectRec(
			"article",
			array("title","content"),
			array(
				CSql::clCond( "alist_id", "=", $org_id ),
				CSql::clCond( "status", "=", 1 ),
			),
			"ORDER BY " . CSql::expOrderBy( array("idx"=>"ASC") )
		);

		$idx = 1;
		foreach( $rsx as $rs ) {
			$vx = array();
			$vx["dt_create"] = gmdate("Y-m-d H:i:s");
			$vx["alist_id"] = $new_id;
			$vx["status"] = 1;
			$vx["idx"] = $idx;
			$vx["title"] = $rs["title"];
			$vx["content"] = $rs["content"];
			CTable::insertRec( "article", $vx );
			$idx++;
		}

	}
}

?>