/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// php Infinite Scroll v2.21
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : NFSRL-221
// URL : http://www.phpkobo.com/php-infinite-scroll
//
// This software is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; version 2 of the
// License.
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/

(function($){

CDlgArticle= {

	setup : function() {
		if ( this.b_setup ) { return; }
		this.b_setup = true;

		var _this = this;

		if ( !this.jqo_ctar ) {
			this.jqo_ctar = $(".dlgarticle");
		}

		this.jqo_ctar_form = this.jqo_ctar.find(".ctar-form");
		this.jqo_btn_ok = this.jqo_ctar.find(".btn-ok");
		this.jqo_title = this.jqo_ctar.find("input[name='title']");
		this.jqo_content = this.jqo_ctar.find("textarea[name='content']");

		this.jqo_ctar
			.keydown(function(e){
				if ( e.which == 27 ) {//ESC
					e.preventDefault();
					_this.pc_cancel();
				}
			});

		this.jqo_ctar.find(".btn-cancel,.btn-close")
			.click( function(e){
				e.preventDefault();
				_this.pc_cancel();
			});

		this.jqo_btn_ok
			.click( function(e){
				e.preventDefault();
				_this.pc_ok();
			});

		this.rwin = new CRWindow({
			cwin:this,
			max_w:900,
			max_h:600,
			min_h:300
		});
	},

	open : function( opt ) {
		for ( var key in opt ) { this[key] = opt[key]; }
		this.setup( opt );

		//-- open
		this.rwin.open();

		//-- clear error states
		CForm.setFRes( this.jqo_ctar_form );

		//-- activate
		this.jqo_content.val("");
		this.jqo_title.val(this.title);
		this.jqo_title.select();

		if ( this.id ) {
			//-- load
			var requ = {
				cmd:"load",
				id:this.id,
			};
			this.cajax.send(requ,this,function(resp){
				var b = CFRes.execute(resp);
				if ( b ) {
					this.jqo_ctar_form.find("textarea[name='content']")
						.val(resp.content);
				} else {
					this.pc_cancel();
				}
			});
		}
	},

	pc_ok : function() {
		var id = ( this.b_tmp ) ? this.id : 0;

		var form = CForm.get(this.jqo_ctar_form);
		var requ = {
			cmd:"save",
			alist_id:this.alist_id,
			id:id,
			form:form
		};

		this.cajax.send(requ,this,function(resp){
			var b = CFRes.execute(resp,this.jqo_ctar_form);
			this.rwin.redraw();
			if ( b ) {
				this.rwin.close();
				if ( this.onOK ) {
					this.onOK(resp.id,form);
				}
			}
		});
	},

	pc_cancel : function() {
		this.rwin.close();
		if ( this.onCancel ) {
			this.onCancel();
		}
	},

	onRedraw : function() {
		this.jqo_ctar.css({
			width:this.rwin.jqo_rwin.width() + "px",
			height:this.rwin.jqo_rwin.height() + "px"
		});

		var jqo_content = this.jqo_ctar.find("textarea[name='content']");
		var h = (this.rwin.jqo_rwin.height()-(50*2+120+10));
		jqo_content.css({
			height:h + "px"
		});
	}
};

}(jQuery));
