/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// php Infinite Scroll v2.21
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : NFSRL-221
// URL : http://www.phpkobo.com/php-infinite-scroll
//
// This software is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; version 2 of the
// License.
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/

(function($){

function CInpArticle( opt ) {
	for ( var key in opt ) { this[key] = opt[key]; }
	this.setup();
};

CInpArticle.prototype = {

	handler_resize : null,
	setupResizeHandler : function() {
		var _this = this;
		if ( this.handler_resize ) {
			$( window ).unbind( "resize", this.handler_resize );
		}
		this.handler_resize = function() {
			setTimeout(function(){
				_this.onResized();
			},100);
		};
		this.handler_resize();
		$( window ).bind( "resize", this.handler_resize );
	},

	onResized : function() {
		this.changeLine();
	},

	breakpoint : 752,
	getChangeLineMode : function() {
		var b_new = ( $(window).width() >= this.breakpoint );
		var b_curr = ( this.jqo_editor.attr("data-mode") == "1" );

		if ( b_new && !b_curr ) {//=>change to 1 line
			return 1;
		}
		if ( !b_new && b_curr ) {//=>change to 2 lines
			return 2;
		}
		return 0;
	},

	change1Line : function( jqo_panel ) {
		var jqo_ctns = jqo_panel.find(".inparticle-panel-content");
		var jqo_1 = jqo_ctns.eq(1);
		var jqo_2 = jqo_ctns.eq(0);
		var jqo_1_d = jqo_1.find(".inparticle-cell-dummy");
		jqo_1_d.after(jqo_2.find(".inparticle-cell-txt"))
		jqo_1_d.after(jqo_2.find(".inparticle-cell-edit"))
		jqo_1_d.remove();
		jqo_2.remove();
	},

	change2Lines : function( jqo_panel ) {
		var jqo_1 = jqo_panel.find(".inparticle-panel-content");
		jqo_1.find(".inparticle-cell-edit")
			.before($("<td>")
				.attr("class","inparticle-cell-dummy")
			);
		var jqo_2 = jqo_1.clone();
		jqo_2.find("td").remove();
		jqo_2.find("tr")
			.append(jqo_1.find(".inparticle-cell-edit"))
			.append(jqo_1.find(".inparticle-cell-txt"))
		jqo_1.before(jqo_2);
	},

	changeLine : function() {
		var _this = this;
		switch( this.getChangeLineMode() ) {
		case 1:
			this.jqo_board.children().each(function(){
				_this.change1Line($(this));
			});
			this.jqo_editor.attr("data-mode",1);
			break;

		case 2:
			this.jqo_board.children().each(function(){
				_this.change2Lines($(this));
			});
			this.jqo_editor.attr("data-mode",2);
			break;
		}
	},

	check : function( jqo, nobg ) {
		jqo.attr("data-sel",1);
		jqo.find("span")
		.removeClass("glyphicon-unchecked")
		.addClass("glyphicon-check");
		if ( nobg === undefined ) {
			jqo.parents(".inparticle-panel")
				.addClass("has-check");
			this.onSelNumChange();
		}
	},

	uncheck : function( jqo, nobg  ) {
		jqo.attr("data-sel",0);
		jqo.find("span")
		.removeClass("glyphicon-check")
		.addClass("glyphicon-unchecked");
		if ( nobg === undefined ) {
			jqo.parents(".inparticle-panel")
				.removeClass("has-check");
			this.onSelNumChange();
		}
	},

	addNew : function( jqo, id, title ) {
		id = id || 0;
		title = title || "";

		var html = $("#inparticle-panel-tpl").html();

		if ( jqo == undefined ) {
			this.jqo_board.prepend(html);
			var jqo_new = this.jqo_board.children(".inparticle-panel").first();
		} else if ( jqo == "init" ) {
			this.jqo_board.append(html);
			var jqo_new = this.jqo_board.children(".inparticle-panel").last();
		} else {
			jqo.after(html);
			var jqo_new = jqo.next(".inparticle-panel");
		}
		this.initPanel(jqo_new);

		if ( this.jqo_editor.attr("data-mode") == "2" ) {
			this.change2Lines( jqo_new );
		}

		this.onTotalChange();

		jqo_new.attr("data-id",id);
		jqo_new.attr("data-b-tmp",0);
		jqo_new.find(".inparticle-txt").val(title);
		if ( jqo != "init" ) {
			jqo_new.find(".inparticle-edit").focus();
		}
	},

	delPenel : function() {
		var jqo = this.jqo_board.find(".inparticle-pbtn[data-sel='1']");
		if (jqo.length) {
			jqo.parents(".inparticle-panel").remove();
			this.onSelNumChange();
			this.onTotalChange();
		}
	},

	onSelNumChange : function() {
		var total = this.jqo_board.find(".inparticle-pbtn-sel").length;
		var selnum = this.jqo_board.find(".inparticle-pbtn-sel[data-sel='1']").length;
		if ( selnum == total ) {
			this.check(this.jqo_header.find(".inparticle-pbtn-sel"),true);
		}
		if ( selnum == 0 ) {
			this.uncheck(this.jqo_header.find(".inparticle-pbtn-sel"),true);
		}
		this.jqo_pbtn_del.prop( "disabled", ( selnum == 0 ) );
		this.jqo_editor.find(".inparticle-selnum").html(selnum);
	},

	onTotalChange : function() {
		var total = this.jqo_board.find(".inparticle-panel").length;
		this.jqo_editor.find(".inparticle-total").html(total);
	},

	initDivBtn : function( jqo, func ) {
		jqo
		.click(func)
		.keypress(function(e) {
			if ((e.which == 13) || (e.which == 32)) {
				func.call(this,e);
			}
		});
	},

	initHeader : function() {
		var _this = this;

		//-- addnew
		this.initDivBtn(this.jqo_header.find(".inparticle-pbtn-addnew"),function(e){
			e.preventDefault();
			_this.addNew();
		});

		//-- sel
		this.initDivBtn(this.jqo_header.find(".inparticle-pbtn-sel"),function(e){
			e.preventDefault();
			if ( parseInt($(this).attr("data-sel")) ){
				_this.uncheck($(this),true);
				_this.uncheck(_this.jqo_board.find(".inparticle-pbtn-sel"));
			} else {
				_this.check($(this),true);
				_this.check(_this.jqo_board.find(".inparticle-pbtn-sel"));
			}
		});
	},

	initFooter : function() {
		var _this = this;

		this.jqo_pbtn_del
		.click(function(e){
			_this.delPenel();
		});
	},

	initPanel : function( jqo_panel ) {
		var _this = this;

		jqo_panel
		.on("up",function(){
			var jqo_prev = $(this).prev();
			if ( jqo_prev.length ) {
				$(this).prev().before($(this));
			} else {
				$(this).parent()
					.children()
					.last()
					.after($(this));
			}
			$(this).find(".inparticle-pbtn-up").focus();
		})
		.on("down",function(){
			var jqo_next = $(this).next();
			if ( jqo_next.length ) {
				$(this).next().after($(this));
			} else {
				$(this).parent()
					.children()
					.first()
					.before($(this));
			}
			$(this).find(".inparticle-pbtn-down").focus();
		})
		.on("addnew",function(){
			_this.addNew($(this));
		});

		jqo_panel.find(".inparticle-pbtn-handle")
		.mousedown(function(e){
			_this.mousedown(e,$(this).parents(".inparticle-panel"));
		});

		//-- up
		this.initDivBtn(jqo_panel.find(".inparticle-pbtn-up"),function(e){
			e.preventDefault();
			$(this).parents(".inparticle-panel").trigger("up");
		});

		//-- down
		this.initDivBtn(jqo_panel.find(".inparticle-pbtn-down"),function(e){
			e.preventDefault();
			$(this).parents(".inparticle-panel").trigger("down");
		});

		//-- edit
		jqo_panel.each(function(){
			var jqo_pbtn_edit = $(this).find(".inparticle-pbtn-edit");

			var func = function(e){
				e.preventDefault();
				var jqo_prt = $(this).parents(".inparticle-panel");

				CDlgArticle.open({
					cajax:_this.cajax,
					alist_id:_this.alist_id,
					id:parseInt(jqo_prt.attr("data-id")),
					b_tmp:parseInt(jqo_prt.attr("data-b-tmp")),
					title:jqo_prt.find(".inparticle-txt").val(),
					onOK : function( id, form ){
						jqo_prt.attr("data-id",id);
						jqo_prt.attr("data-b-tmp",1);
						jqo_prt.find(".inparticle-txt").val(form.title);
						jqo_prt.removeClass("has-error");
					},
					onCancel : function(){
						//
					}
				});
			};

			_this.initDivBtn(jqo_pbtn_edit,func);
		});

		//-- txt
		jqo_panel.find(".inparticle-cell-txt")
			.click(function(){
				$(this).parents(".inparticle-panel")
					.find(".inparticle-pbtn-edit")
					.click();
			});

		//-- addnew
		this.initDivBtn(jqo_panel.find(".inparticle-pbtn-addnew"),function(e){
			e.preventDefault();
			$(this).parents(".inparticle-panel").trigger("addnew");
		});

		//-- sel
		this.initDivBtn(jqo_panel.find(".inparticle-pbtn-sel"),function(e){
			e.preventDefault();
			if ( parseInt($(this).attr("data-sel")) ){
				_this.uncheck($(this));
			} else {
				_this.check($(this));
			}
		});
	},

	mousedown : function(e,jqo) {
		if ( this.scroll_board.canMouseCapture(e) ) {
			this.scroll_board.addMouseCapture( e, jqo );
		}
	},

	setup : function() {
		this.cajax = new CCAjax({
			url_be:url_be_entry_inparticle
		});
		this.jms = new CJMS();

		var html = $("#inparticle-editor-tpl").html();
		this.jqo_inp.before(html);
		this.jqo_editor = this.jqo_inp.prev();

		this.jqo_header = this.jqo_editor.find(".inparticle-header");
		this.jqo_footer = this.jqo_editor.find(".inparticle-footer");
		this.jqo_pbtn_del = this.jqo_footer.find(".inparticle-pbtn-del");
		this.jqo_board = this.jqo_editor.find(".inparticle-body .inparticle-board");

		this.newid_idx = 0;

		this.scroll_board = new CScrollBoard({
			dir:"v",
			jqo_ctar:this.jqo_editor,
			jqo_board:this.jqo_board,
			onSpaceCreated:function(jqo_space,jqo_moving){
				jqo_space
				.addClass("inparticle-panel-space")
				.css({
					width:jqo_moving.outerWidth()+"px",
					height:jqo_moving.outerHeight()+"px"
				});
			},
			onBeginMove:function(jqo_moving){
				jqo_moving
				.css({
					width:jqo_moving.outerWidth()+"px",
					height:jqo_moving.outerHeight()+"px"
				});
			},
			onEndMove:function(jqo_moving){
				jqo_moving
				.css({
					width:"auto",
					height:"auto"
				});
			}
		});

		//-- init
		var data = JSON.parse(this.jqo_inp.val());
		this.alist_id = data.alist_id;
		for( var i = 0; i<data.list.length; i++ ) {
			var rec = data.list[i];
			this.addNew("init",rec.id,rec.title);
		}

		this.initHeader();
		this.initFooter();
		this.onSelNumChange();
		this.onTotalChange();
		this.setupResizeHandler();
	},

	getData : function(){
		var ls = [];
		this.jqo_board.find(".inparticle-panel").each(function(){
			data = {
				id : $(this).attr("data-id")
			};
			ls.push( data );
		});
		return ls;
	},

	msgProc : function( msg ){
		switch ( msg.event ) {
		case "saved":
			this.jqo_board.find(".inparticle-panel").each(function(){
				$(this).attr("data-b-tmp",0);
			});
			break;
		case "error":
			if ( msg.resp["inparticle"] ) {
				var err = msg.resp["inparticle"];
				for( idx in err ) {
					this.jqo_board.find(".inparticle-panel")
						.eq(idx)
						.addClass("has-error");
				}
			}
			break;
		}
	}

};

window.initCInpArticle = function() {
	$(".inparticle").each( function(){
		if ( !$(this).data("_obj_") ) {
			var obj = new CInpArticle({jqo_inp:$(this)});
			$(this).data("_obj_",obj);
		}
	});
};

})(jQuery);

